routes/web.php
<?php

use App\Http\Controllers\web\LanguageController;
use App\Http\Controllers\web\ContactController;
use App\Http\Controllers\web\DarkThemeController;
use App\Http\Controllers\web\CommentController;
use App\Http\Controllers\web\OrderController;
use App\Http\Controllers\web\ProductController;
use App\Http\Controllers\web\UserController;
use Illuminate\Support\Facades\Route;
use \App\Http\Controllers\web\CategoryController;
use \App\Http\Controllers\web\CartController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::view('/', 'static_sites.start')->name('start_view');
Route::post('/contact', ContactController::class)->name('web.contact_form');
Route::view('/contact', 'static_sites.contact')->name('contact_view');

Route::redirect('products/comments', '/products/comments/start');
Route::resource('products', ProductController::class, ['as' => 'web', 'except' => '']);
//Route::resource('products', ProductController::class);
Route::resource('products.comments', CommentController::class, ['as' => 'web', ]);
Route::get('products/comments/start', [CommentController::class, 'start'])->name('web.products.start');
Route::get('products/{slug}', [ProductController::class, 'show'])->name('web.products.show');

Route::group([
    // 'prefix' => 'pl', //  do geta
    'as' => 'web.',
    'middleware' => [
        // 'verified',
        // 'auth',
        // 'userLogs'
    ],
    ], function() {
        Route::get('categories/', [CategoryController::class, 'index'])->name('categories.index');
        // Route::get('categories/{category}', [CategoryController::class, 'show'])->name('categories.show');
        Route::get('categories/{slug}', [CategoryController::class, 'show'])->name('categories.show');

        // Route::get('users', [UserController::class, 'index'])->name('users.index');
        // Route::get('users/{user}', [UserController::class, 'edit'])->name('users.edit');
        // Route::delete('users/{user}', [UserController::class, 'destroy'])->name('user.delete');
        Route::resource('users', UserController::class)->only(['index', 'edit', 'update', 'destroy']);

        Route::get('cart/index', [CartController::class, 'index'])->name('cart.index');
        Route::post('cart/{product}/{goBackWithMessage?}', [CartController::class, 'store'])->name('cart.store');
        Route::delete('cart/{product}', [CartController::class, 'destroy'])->name('cart.destroy');

        Route::get('orders', [OrderController::class, 'index'])->name('orders.index');
        Route::post('orders', [OrderController::class, 'store'])->name('orders.store');
        Route::get('orders/{order}', [OrderController::class, 'show'])->name('orders.show');
    }
);

Route::get('/dark-theme', DarkThemeController::class)->name('web.dark_theme');
Route::get('lang/{lang}', [LanguageController::class, 'switchLang'])->name('web.lang_switch');

app/Models/Product.php
<?php declare(strict_types=1);

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Product extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'slug', 'description', 'price'];

    public function comments() : HasMany
    {
        return $this->hasMany(Comment::class);
    }

    /**
     * @TODO Refactor zaprogramuj życie - kategorie
     */
    //    public function isSelectedCategory(int $category_id): bool
    //    {
    //        return $this->hasCategory() && $this->category->id = $category_id;
    //    }

    //    public function hasCategory()
    //    {
    //        return !is_null($this->category);
    //    }

    public function category() : BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function orders(): BelongsToMany
    {
        return $this->belongsToMany(Order::class);
    }
}

app/Http/Controllers/api/v1/ProductController.php
<?php declare(strict_types=1);

namespace App\Http\Controllers\api\v1;

use App\Http\Controllers\Controller;
use App\Http\Requests\ProductPostRequest;
use App\Http\Resources\ProductResource;
use App\Models\Product;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Symfony\Component\HttpFoundation\Response as SymfonyResponse;

/**
 * https://laravel.com/docs/8.x/controllers
 */
class ProductController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return ProductResource::collection(Product::all());
        return Product::paginate(4);
        return \DB::table('products')->paginate(3);
        return Product::all();
    }

    public function pagination(int $perPage = 10)
    {
        $list = Product::paginate($perPage);
        return response()->json($list, 200);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create() : Response
    {
        die;
    }

    /**
     * Store a newly created resource in storage.
     * POSTMAN:
     * Headers: application/json
     * Body: form-data
     * Body: name: Product Two
     * Body: slug: product-two
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductPostRequest $request)
    {
        // return Product::create($request->all());
        $product = Product::create($request->validated());
        return new ProductResource($product);
    }

    public function show(Product $product) : ProductResource
    {
        return new ProductResource($product);
        // return $product;
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id) : Response
    {
        die;
    }

    public function update(ProductPostRequest $request, int $id) : Response
    {
        $validated = $request->validated();
        $product = Product::findOrFail($id);
    }

    public function destroy(int $id) : SymfonyResponse
    {
        $product = Product::findOrFail($id); // 500
        // $product = Product::find($id); // 500
        $product->delete();

        // HTTP Status 204 (No Content) - RESTful API
        return response(null, SymfonyResponse::HTTP_NO_CONTENT);
        return response(null, 204);
    }
}

app/Http/Controllers/web/ProductController.php
<?php

namespace App\Http\Controllers\web;

use App\Http\Controllers\Controller;
use App\Http\Requests\ProductPostRequest;
use App\Http\Requests\ProductUpdateRequest;
use App\Models\Comment;
use App\Models\Product;
use App\Repositories\ProductRepository;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\View\View;

class ProductController extends Controller
{
    private ProductRepository $productRepository;

    /**
     * @TODO  wstrzykiwać interfejs
     * np.:
     * https://www.twilio.com/blog/repository-pattern-in-laravel-application
     * @param ProductRepository $productRepository
     */
    public function __construct(ProductRepository $productRepository)
    {
        $this->productRepository = $productRepository;
    }

    public function index(): View
    {
        $products = Product::paginate(9);
        // $products =  $this->productRepository->getAll();
        // $products = Product::all();
        return view('products.index', compact('products'));
    }

    public function create(): View
    {
        return view('products.create');
    }

    public function store(ProductPostRequest $request) : View
    {
        $product = Product::create($request->validated());
        return view('products.show', compact('product'))->with('success', 'Success');;
    }

    public function show(string $slug) : View
    {
        $product = Product::with(['comments', 'category'])
            ->where('slug', $slug)
            ->firstOrFail();
         return view('products.show', compact('product', ));
    }

    public function edit(string $slug): View
    {
        $product = Product::where('slug', $slug)->firstOrFail();
        return view('products.edit', compact('product'));
    }

    public function update(ProductUpdateRequest $request, $id)
    {
        $product = Product::findOrFail($id);
        $product->update($request->validated());
        return redirect()
            ->route('products.show', ['slug' => $request->validated()['slug']])
            ->with('success', 'Product updated');
    }

    public function destroy(Product $product): RedirectResponse
    {
        $product->delete();
        return redirect()->route('web.products.index')->with('success', 'Product deleted!');
    }
}

resources/views/products/create.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')
    <div class="card  pt-5 mb-4">
        <div class="card-body">
            <h1 class="display-1 text-center">Create a product</h1>
            <p class="text-center lead my-4">***</p>
            @include('layout.my_monolit.site_elements.form_errors')
            <form action="{{ route('web.products.store') }}" method="post">
                @method('POST')
                @csrf
                @include('products.form')
                <input type="submit" class="btn btn-success" value="Add product">
            </form>
        </div>
    </div>
@endsection

resources/views/products/edit.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')
    <div class="card  pt-5 mb-4">
        <div class="card-body">
            <h1 class="display-1 text-center">Edit a product</h1>
            <p class="text-center lead my-4">***</p>
            @include('layout.my_monolit.site_elements.form_errors')
            <form action="{{ route('web.products.update', ['product' => $product->id]) }}" method="post">
{{--                @method('PUT')--}}
                @method('PATCH')
                @csrf
                @include('products.form')
                <input type="submit" class="btn btn-success" value="Update product">
            </form>
            <form action="{{ route('web.products.destroy', ['product' => $product->id]) }}" method="POST">
                @csrf
                @method('DELETE')
                <input type="submit" class="btn btn-danger mt-2" value="Delete product">
            </form>
        </div>
    </div>
@endsection

resources/views/products/form.blade.php
<div class="mb-3">
    <label for="name" class="form-label">Product name</label>
    <input type="text" class="form-control" id="name" name="name" placeholder="Product name" value="{{ old('name') ?? $product->name ?? '' }}">
    <div id="nameHelp" class="form-text small">Required field</div>
</div>
<div class="mb-3">
    <label for="description" class="form-label">{{ __('products.form.label.description') }}</label>
    <textarea class="form-control" name="description" id="description" rows="3" placeholder="...">{{ old('description') ?? $product->description ?? '' }}</textarea>
    <div id="descriptionHelp" class="form-text small">Required field</div>
</div>
<div class="mb-3">
    <label for="price" class="form-label">Price</label>
    <input type="number" name="price" class="form-control" id="price" placeholder="Price" value="{{ old('price') ?? $product->price ?? '' }}">
    <div id="numberHelp" class="form-text small">Required field</div>
</div>

resources/views/products/index.blade.php
@extends('layout.my_monolit')

@section('title', 'Products')

@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
<section id="products">
    <div class="card pt-5 mb-4">
        <div class="card-body">
            <div class="mb-5">
                <h1 class="display-1 text-center">Our products</h1>
                 <p class="lead text-center">See our prducts</p>
            </div>

            <div class="row">
                    @forelse($products as $item)
                    <div class="col-md-4">
                        <div class="card mb-3">
                            <div class="card-body text-center">
                                <h4><a class="text-decoration-none" href="{{ route('web.products.show', ['slug' => $item->slug]) }}">{{ $item->name }}</a></h4>
                                <p>****</p>
                                <p>price: {{ $item->price }} EUR</p>
                            </div>
                            <div class="card-footer small d-flex justify-content-between">
                                <div>
                                    <a class="btn btn-sm btn-outline-primary" href="{{ route('web.products.show', ['slug' => $item->slug]) }}">Show</a>
                                </div>
                                <div class="d-flex">
                                    <div class="me-2">
                                        <form class="d-inline-block" action="{{ route('web.cart.store', ['product' => $item->id, 'goBackWithMessage' => true]) }}" method="post">
                                            @csrf
                                            @method('POST')
                                            <button type="submit" class="btn btn-sm btn-outline-info"><i class="fas fa-shopping-cart"></i></button>
                                        </form>
                                        <a class="btn btn-sm btn-outline-info" href="{{ route('web.products.edit', ['product' => $item->slug]) }}"><i class="far fa-edit"></i></a>
                                    </div>
                                    <div>
                                        <form action="{{ route('web.products.destroy', ['product' => $item->id]) }}" method="POST">
                                            @method('DELETE')
                                            @csrf
{{--                                            <input type="submit" class="btn btn-sm btn-outline-danger" value="Delete">--}}
                                            <button type="submit" class="btn btn-sm btn-outline-danger"><i class="far fa-trash-alt"></i></button>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    @empty
                        <p class="lead">No products in this category!</p>
                    @endforelse
            </div>

            <div class="my-3">
                {{ $products->links() }}
            </div>
        </div>
    </div>
</section>
@endsection

resources/views/products/show.blade.php
@extends('layout.my_monolit')
@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
    <div class="card text-center py-5 mb-4">
        <div class="card-body">
            <h1 class="display-1">{{ $product->name }}</h1>
            <p class="lead">{{ $product->description }}</p>
            <p class="py-3" class="text-muted">
                {{ __('shop.price.name') }} {{ $product->price }} {{ __('shop.price.shortcut') }}
            </p>
            <div class="py-3">
                @include('layout.my_monolit.site_elements.link_btn_dark', ['href' => url()->previous(), 'text' => 'Previous'])
                <a class="btn btn-dark" href="{{ url()->previous() }}">Previous</a>
                @include('layout.my_monolit.site_elements.link_btn_dark', ['href' => route('web.products.edit', ['product' => $product->slug]), 'text' => 'Edit'])
            </div>
            <div>
                <a class="btn btn-outline-dark px-5" href="{{ route('web.categories.show', ['slug' => $product->category->slug]) }}">{{ $product->category->name }}</a>
                <div class="mt-3">
                    <form action="{{ route('web.cart.store', ['product' => $product->id]) }}" method="POST">
                        @csrf
                        @method('POST')
                        <input type="submit" class="btn btn-outline-info" value="Add to chart">
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-3">
        <div class="col col-lg-8">
            <article>
                <h3 class="display-6 mt-4 mb-2">Add a comment:</h3>
                @include('layout.my_monolit.site_elements.form_errors')
                <form action="{{ route('web.products.comments.store', ['product' => $product->id]) }}" method="POST">
                    @csrf
                    @method('POST')
                    @include('products.comments.form')
                    <input type="submit" class="btn btn-outline-dark" value="Add">
                </form>
            </article>
            <div>
                <hr class="my-4">
                <h4 class="lead mb-3">Comments: {{ $product->comments->count() }}</h4>
                @forelse($product->comments as $comment)
                    @include('products.comments.comment')
                @empty
                    <p>No comments!</p>
                @endforelse
            </div>
        </div>
    </div>
@endsection